// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.

define(["cloudera/Util","cloudera/common/Monitor","cloudera/cmf/charts/Plot","cloudera/cmf/charts/TimeSeriesVisualizer","cloudera/common/UrlParams","underscore"],function(e,t,n,r,i,s){describe("TimeSeriesVisualizer Tests",function(){function h(e){spyOn(e,"createVisualizer").andReturn(f),spyOn(f,"renderPlaceholder"),e.render(l)}var o,u="tcVisualizerContainer",a={plot:{tsquery:"Some Query",title:"My Chart Title",chartType:n.ChartType.LINE},container:"#"+u,enableFacets:!0},f={isRendered:function(){return!1},render:function(){},renderPlaceholder:function(){}},l={timeSeries:[{data:[{x:1,y:2}],metadata:{attributes:{}}},{data:[{x:2,y:3}],metadata:{attributes:{}}},{data:[],metadata:{}},{}]},c=new t("TimeSeriesVisualizer.render");beforeEach(function(){$('<div id="'+u+'"></div>').appendTo(document.body)}),afterEach(function(){o.unsubscribe(),$("#"+u).remove()}),it("should create a TimeSeriesVisualizer object",function(){o=new r(a),expect(o.facets).toBeDefined(),expect(o.getViewModel()).toBeDefined()}),it("should test the TimeSeriesVisualizer.render method",function(){o=new r(a),spyOn(o.facets,"update"),spyOn(o,"createVisualizer").andReturn(f),spyOn(f,"renderPlaceholder"),o.render(l),expect($("#"+u).find(".yAxis").length).toEqual(2),expect($("#"+u).find(".chart").length).toEqual(2),expect($("#"+u).find(".chart-container").length).toEqual(2),expect($("#"+u).find(".chart-title").length).toEqual(3),expect(f.renderPlaceholder).wasCalled(),expect(o.vizs.length).toEqual(2),expect(o.facets.update).wasCalled()}),it("should test the TimeSeriesVisualizer.render method without yAxis",function(){var e=$.extend(!0,{},a);e.plot.showYAxis=!1,o=new r(e),spyOn(o.facets,"update"),spyOn(o,"createVisualizer").andReturn(f),spyOn(f,"renderPlaceholder"),o.render(l),expect($("#"+u).find(".yAxis").length).toEqual(0),expect($("#"+u).find(".chart").length).toEqual(2),expect($("#"+u).find(".chart-container").length).toEqual(2),expect($("#"+u).find(".chart-title").length).toEqual(3),expect(f.renderPlaceholder).wasCalled(),expect(o.vizs.length).toEqual(2),expect(o.facets.update).wasCalled()}),it("should test the TimeSeriesVisualizer.regroupTimeSeries method",function(){o=new r(a);var e=[{data:[{x:1,y:2}],metadata:{attributes:{a:"a0",b:"b1"}}},{data:[{x:2,y:3}],metadata:{attributes:{a:"a0",b:"b0"}}},{data:[{x:3,y:4}],metadata:{attributes:{a:"a0",b:"b0"}}}],t=o.regroupTimeSeries(e,n.FACETTING_SINGLE_PLOT);expect(t[0].value).toEqual(e),t=o.regroupTimeSeries(e,"a"),expect(t[0].value.length).toEqual(3),t=o.regroupTimeSeries(e,"b"),expect(t[0].value.length).toEqual(2),expect(t[1].value.length).toEqual(1),t=o.regroupTimeSeries(e,"a,b"),expect(t[0].value.length).toEqual(2),expect(t[1].value.length).toEqual(1),t=o.regroupTimeSeries(e,n.FACETTING_NONE),expect(t[0].value[0]).toEqual(e[0]),expect(t[1].value[0]).toEqual(e[1]),expect(t[2].value[0]).toEqual(e[2])}),it("should catch the clickFacetGroup event",function(){o=new r(a),spyOn(o,"render"),$.publish("clickFacetGroup",[n.FACETTING_NONE]),expect(o.render).wasCalled()}),it("should ensure enlargeable class is added",function(){o=new r(a),h(o);var e=$("#"+u).find(".chart-container");expect(e.hasClass("enlargeable")).toBeTruthy()}),it("should ensure enlargeable class is not added",function(){var e=$.extend({},a,{enableEnlarging:!1});o=new r(e),h(o);var t=$("#"+u).find(".chart-container");expect(t.hasClass("enlargeable")).toBeFalsy()}),it("should test the various actions",function(){var e=$.extend(!0,{enableEditing:!0,enableCloning:!0,enableRemoving:!0},a);o=new r(e),h(o),spyOn($,"publish");var t=$("#"+u);t.find(".edit-chart").trigger("click"),expect($.publish).wasCalled(),expect($.publish.mostRecentCall.args[0]).toEqual("editPlot"),t.find(".clone-chart").trigger("click"),expect($.publish).wasCalled(),expect($.publish.mostRecentCall.args[0]).toEqual("clonePlot"),t.find(".remove-chart").trigger("click"),expect($.publish).wasCalled(),expect($.publish.mostRecentCall.args[0]).toEqual("removePlot")}),it("should test setDimension",function(){o=new r(a),spyOn(o,"adjustTitleWidth"),spyOn(o,"setChartDimension"),o.setDimension(200,300),expect(o.adjustTitleWidth.mostRecentCall.args[1]).toBeDefined(),expect(o.setChartDimension.mostRecentCall.args[1]).toBeDefined()}),it("should render a legend conditional on the number of streams",function(){var e=function(){return{data:[{x:1,y:2}],metadata:{attributes:{}}}},t=s.defaults({plot:{tsquery:"Some Query",chartType:n.ChartType.LINE,showLegend:!0,facetting:n.FACETTING_SINGLE_PLOT}},a);o=new r(t);var i={timeSeries:s.map(s.range(50),e)};spyOn(o,"addLegendContainer"),spyOn(o,"createVisualizer").andCallThrough(),o.render(i),expect(o.addLegendContainer).wasCalled(),o.addLegendContainer.reset();var u=o.createVisualizer.mostRecentCall.args;expect(u[0].showLegend).toBeTruthy(),i.timeSeries.push(e()),o.render(i),expect(o.addLegendContainer).wasNotCalled(),u=o.createVisualizer.mostRecentCall.args,expect(u[0].showLegend).toBeFalsy()}),it("should test setFilter",function(){o=new r(a),spyOn(o,"deferRenderVisibleCharts"),o.render(l),o.setFilter("Hello World"),expect(o.$chartsContainer.find(".chart-container:visible").length).toEqual(0),o.setFilter("Chart"),expect(o.$chartsContainer.find(".chart-container:visible").length).toEqual(2),expect(o.deferRenderVisibleCharts).wasCalled(),spyOn(o,"setFilter"),o.render(l),expect(o.setFilter).wasCalledWith("Chart")}),it("should test matchesFilter",function(){o=new r(a),o.timeSeriesResponse={timeSeries:["dontcare"]},spyOn(o,"render"),o.setFilter("Hello Cloudera"),expect(o.matchesFilter("Hello Cloudera Manager")).toBeTruthy(),expect(o.matchesFilter("Cloudera Manager Hello")).toBeTruthy(),expect(o.matchesFilter("Hello Manager")).toBeFalsy()}),it("should make sure matched charts are rendered",function(){var e=$.extend({},a,{plot:{tsquery:"Some Query",chartType:n.ChartType.LINE,title:"My Plot Title"}});spyOn($.fn,"hide").andCallThrough(),o=new r(e),h(o),o.setFilter("Plot Title"),expect(o.createVisualizer.callCount).toEqual(2),expect($.fn.hide).wasNotCalled()}),it("should make sure unmatched charts are not rendered",function(){var e=$.extend({},a,{plot:{tsquery:"Some Query",chartType:n.ChartType.LINE,title:"My Plot Title"}});spyOn($.fn,"hide").andCallThrough(),o=new r(e),h(o),o.setFilter("Blah Blah"),expect(o.createVisualizer.callCount).toEqual(2),expect($.fn.hide).wasCalled()}),it("should not call enableProgressiveLoading if enableLoadAll is true",function(){var e=$.extend({},a,{enableLoadAll:!0});spyOn(r.prototype,"enableProgressiveLoading").andCallThrough(),o=new r(e),expect(r.prototype.enableProgressiveLoading).wasNotCalled()}),it("should call enableProgressiveLoading if enableLoadAll is undefined or false",function(){var e=$.extend({},a,{enableLoadAll:!1});spyOn(r.prototype,"enableProgressiveLoading").andCallThrough(),o=new r(e),expect(r.prototype.enableProgressiveLoading).wasCalled()}),it("should call render if enableLoadAll is true",function(){var e=$.extend({},a,{enableLoadAll:!0});o=new r(e),spyOn(o,"createVisualizer").andReturn(f),spyOn(f,"render"),spyOn(f,"renderPlaceholder"),o.render(l),expect(f.render).wasCalled(),expect(f.renderPlaceholder).wasNotCalled()}),it("should call renderPlaceholder if enableLoadAll is false",function(){var e=$.extend({},a,{enableLoadAll:!1});o=new r(e),spyOn(o,"createVisualizer").andReturn(f),spyOn(f,"render"),spyOn(f,"renderPlaceholder"),o.render(l),expect(f.render).wasNotCalled(),expect(f.renderPlaceholder).wasCalled()}),it("should test shouldRender and result in false",function(){o=new r(a),expect(o.shouldRender(50,100,200,800)).toBeFalsy(),expect(o.shouldRender(50,100,10,20)).toBeFalsy()}),it("should test shouldRender and result in true",function(){o=new r(a),expect(o.shouldRender(20,100,20,100)).toBeTruthy(),expect(o.shouldRender(20,100,20,30)).toBeTruthy(),expect(o.shouldRender(20,100,10,30)).toBeTruthy(),expect(o.shouldRender(20,100,30,80)).toBeTruthy(),expect(o.shouldRender(20,100,80,120)).toBeTruthy(),expect(o.shouldRender(20,100,80,100)).toBeTruthy(),expect(o.shouldRender(50,100,20,200)).toBeTruthy()}),it("should test deferRenderVisibleCharts",function(){o=new r(a),e.setTestMode(!1),spyOn(s,"defer"),o.deferRenderVisibleCharts(),expect(s.defer).wasCalled(),e.setTestMode(!0)}),it("should test renderVisibleChartWithinRange",function(){o=new r(a),spyOn(o,"createVisualizer").andReturn(f),spyOn(f,"render"),o.render(l);var e=$("#"+u).find(".chart-container:first");spyOn(e,"offset").andReturn({top:50,left:0}),spyOn(e,"height").andReturn(30),o.renderVisibleChartWithinRange(e,0,100),expect(f.render).wasCalled(),expect(f.render.callCount).toEqual(1),o.renderVisibleChartWithinRange(e,100,200),expect(f.render.callCount).toEqual(1)}),it("should test renderVisibleCharts",function(){o=new r(a),o.render(l),spyOn(o,"renderVisibleChartWithinRange"),spyOn(o,"renderInvisibleChartsWithPlaceholder"),o.renderVisibleCharts($(window)),expect(o.renderVisibleChartWithinRange).wasCalled(),o.$chartsContainer.find(".chart-container").hide(),o.renderVisibleCharts($(window)),expect(o.renderInvisibleChartsWithPlaceholder).wasCalled()}),it("should test showPlotDetails",function(){o=new r(a),o.render(l),spyOn($,"publish");var e=$("#"+u).find(".chart-container:first");e.trigger("click"),expect($.publish).wasCalled(),expect($.publish.mostRecentCall.args[0]).toEqual("showPlotDetails"),expect($.publish.mostRecentCall.args[1][2]).toEqual("My Chart Title")}),it("should test calculateDynamicRange",function(){o=new r(a),o.viewModel.facetting("metric");var e={timeSeries:[{data:[{x:1,y:2},{x:2,y:4}],metadata:{metric:"Metric 1",attributes:{}}},{data:[{x:2,y:3},{x:3,y:5}],metadata:{metric:"Metric 1",attributes:{}}},{data:[{x:3,y:4},{x:4,y:10}],metadata:{metric:"Metric 2",attributes:{}}}]},t=o.getGroupedTimeSeries(e,c);o.calculateDynamicRange(t,c),expect(t[0].ymin).toEqual(2),expect(t[0].ymax).toEqual(5),expect(t[1].ymin).toEqual(4),expect(t[1].ymax).toEqual(10)}),it("should update the url when facet changes",function(){o=new r(a),spyOn(i,"set"),spyOn(o,"render"),$.publish("clickFacetGroup",["hostname"]),expect(i.set).wasCalledWith("facetting","hostname")})})})